package app;

import GL.system.Display;
import static app.Main.display;
import app.author.AuthorScreen;
import app.game.Game;
import app.game.GameLoadScreen;
import app.menu.MenuLoadScreen;
import app.menu.Menu;
import app.player.Listener;

/**
 * @author Death
 */
public class Manager {

    public static Game game;
    public static Menu menu;
    public static AuthorScreen authorScreen;
    public static MenuLoadScreen menuLoad;
    public static GameLoadScreen gameLoad;
    
    public static void initDisplay(){
        display = new Display(900, 600);
        display.setTitle("LandscapeCraft 0.1");
        Manager.startApp();
        display.setCursor(Main.getCursor());
        display.startThread();
    }
    
    public static void startApp(){
        game = null;
        menu = null;
        menuLoad = null;
        gameLoad = null;
        authorScreen = null;
        menuLoad = new MenuLoadScreen();
        menuLoad.setVisible(true);
        Main.display.add(menuLoad);
    }
    
    public static void appAuthor(){
        authorScreen = new AuthorScreen();
        authorScreen.setVisible(true);
        Main.display.add(authorScreen);
        menu.setVisible(false);
    }
    
    public static void appNewMenu(){
        menu = new Menu();
        menu.setVisible(true);
        Main.display.add(menu);
    }
    
    public static void appMenuGoToNewGame(){
        if(game != null)
            return;
        menu.setVisible(false);
        gameLoad = new GameLoadScreen();
        gameLoad.setVisible(true);
        Main.display.add(gameLoad);
    }
    
    public static void appGame(){
        menu.setVisible(false);
        game = new Game();
        game.init();
        game.setVisible(true);
        Main.display.add(game);
    }
    
    public static void appMenu(){
        Main.display.remove(game);
        MusicManager.stop("game");
        MusicManager.play("menu");
        Listener.keyGame.processing = false;
        Listener.keyInv.processing = false;
        Listener.mouseGame.processing = false;
        Listener.mouseInv.processing = false;
        game = null;
        menu.setVisible(true);
    }
}
