package app.ataka;

import GL.system.SM;
import app.Manager;
import app.mobs.Mob;
import app.player.Player;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;

/**
 * @author Death
 */
public class AtakaObj {

    Color color;
    int alfa;
    int x, y;
    String str;
    long timeDelay;
    double dx, dy;

    public AtakaObj(){
        color = new Color(0, 0, 255, 170);
        alfa = 0;
        x = 0;
        y = 0;
        str = "";
        timeDelay = 0;
        double angl = Math.random() * Math.PI;
        int speed = SM.rnd(0, 10) - 5;
        if(speed == 0) speed = -1;
        dx = speed * Math.cos(angl);
        dy = speed * Math.sin(angl);
    }
    
    public void start(Mob m, int ataka){
        thisStrat();
        x = m.x + m.w / 2;
        y = m.y + m.h / 2;
        str = String.valueOf("-" + ataka);
    }
    
    public void start(Player m, int ataka){
        thisStrat();
        x = m.x + m.w / 2;
        y = m.y + m.h / 2;
        str = String.valueOf("-" + ataka);
    }
    
    private void thisStrat(){
        alfa = 255;
        color = new Color(color.getRed(), color.getGreen(), color.getBlue(), alfa);
    }
    
    public void paint(Graphics2D g){
        Font f = g.getFont();
        g.setColor(color);
        g.setFont(new Font("calibri", 0, 26));
        g.drawString(str, Manager.game.map.x + x - SM.getWidthStr(g, str) / 2 - 1, Manager.game.map.y + y + 1);
        g.setColor(new Color(255, 0, 0, alfa));
        g.setFont(new Font("calibri", 0, 23));
        g.drawString(str, Manager.game.map.x + x - SM.getWidthStr(g, str) / 2, Manager.game.map.y + y);
        g.setFont(f);
    }
    
    public void update(){
        if(!(System.currentTimeMillis() - timeDelay > 1000/50))
            return;
        timeDelay = System.currentTimeMillis();
        x += dx;
        y += dy;
        alfa -= 6;
        if(alfa < 0){
            AtakaSys.remove(this);
            return;
        }
        color = new Color(color.getRed(), color.getGreen(), color.getBlue(), alfa);
    }
}
