package app.author;

import GL.system.Display;
import GL.system.SM;
import GL.system.listener.Key;
import GL.system.screen.Render;
import app.Main;
import app.Manager;
import app.game.background.Background;
import com.sun.glass.events.KeyEvent;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

/**
 * @author Death
 */
public class AuthorPanel extends Render{

    String[] str;
    Background back;
    Key key;
    BufferedImage logo;

    public AuthorPanel(){
        str = new String[]{
            "Игра сделана для конкурса сайта aNNiMON.com",
            "Автор Death(Владимир Ефанькин)"
        };
        back = new Background();
        key = new Key();
        Main.display.add(key);
        key.add(new Key.IReleasedKey() {
            @Override
            public void released(int keyCode){
                if(keyCode == KeyEvent.VK_ESCAPE){
                    Main.display.remove(key);
                    Main.display.remove(Manager.authorScreen);
                    Manager.menu.setVisible(true);
                    Manager.authorScreen = null;
                }
            }
        });
        logo = SM.imgFile("./res/logo.png");
    }
    
    @Override
    public void paint(Graphics2D g){
        back.paint(g);
        Font f = g.getFont();
        g.setFont(new Font("calibri", 0, 27));
        for(int i = 0; i < str.length; i++){
            drawString(g, str[i], Display.getWidth() / 2 - SM.getWidthStr(g, str[i]) / 2, logo.getHeight() + 5 + SM.getHeightStr(g, str[i]) + i * (5 + SM.getHeightStr(g, str[i])));
        }
        String exit = "ESC - Выход в меню";
        drawString(g, exit, Display.getWidth() / 2 - SM.getWidthStr(g, exit) / 2, Display.getHeight() - SM.getHeightStr(g, exit) - 5);
        g.setFont(f);
        g.drawImage(logo, Display.getWidth() / 2 - logo.getWidth() / 2, 0, null);
    }
    
    private void drawString(Graphics2D g, String s, int x, int y){
        g.setColor(new Color(150, 150, 150, 150));
        g.drawString(s, x + 2, y + 2);
        g.setColor(new Color(20, 20, 20, 250));
        g.drawString(s, x, y);
    }

    @Override
    public void update(){
        back.update();
    }
    
    
}
