package app.block;

import GL.system.SM;
import app.Manager;
import app.block.material.Material;
import app.item.Item;
import app.item.ItemObjectMap;
import app.item.StaticImage;
import app.item.SysObjectMap;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import static ru.wladimir.map.Setting.SizeTileA;
import ru.wladimir.map.Tile;

/**
 * @author Death
 */
public class Block extends Tile{

    
    public static final int 
            SOLID = 1,
            GAS = 2,
            LIQUID = 3,
            TREE = 4;
    
    
    public static final Block air = (new Block()).init(1, "", "", Block.GAS, 0.0F, null);
    public static final BlockSoil soil = (BlockSoil)(new BlockSoil()).init(2, "Земля", "soil", Block.SOLID, 4.0F, Item.dirst).setMaterial(Material.dirst);
    public static final Block dirst = (new Block()).init(3, "Грязь", "dirst", Block.SOLID, 3.0F, Item.dirst).setMaterial(Material.dirst);
    public static final Block tree = (new Block()).init(4, "Дерево", "tree", Block.TREE, 5.5F, Item.tree).setMaterial(Material.tree);
    public static final Block board = (new Block()).init(5, "Доска", "board", Block.SOLID, 4.0F, Item.board);
    public static final Block stone = (new Block()).init(6, "Камень", "stone", Block.SOLID, 7.6F, Item.cobblestone);
    public static final Block cobblestone = (new Block()).init(7, "Булыжник", "cobblestone", Block.SOLID, 7.0F, Item.cobblestone);
    public static final Block water = ( new Block()).init(8, "Вода", "", Block.LIQUID, 0.0F, null);
    public static final Block foliage = (new Block()).init(9, "Листва", "foliage", SOLID, 1.0F, Item.foliage);
    public static final BlockGrass grass = (BlockGrass)new BlockGrass().init(10, "Трава", "grass", LIQUID, 05.F, Item.grass);
    
    
    BufferedImage image;
    long timeDelay;
    long timeBeginBreaking, timeEndBreaking;
    
    public Item itemDrop;
    public String itemName;
    public String nameImage;
    public String name;
    public Material material;
    public boolean breaking;
    public int type;
    public float strength;

    public Block() {
        super();
        image = null;
        name = "null";
        strength = 0;
        type = 0;
        timeDelay = 0;
        breaking = false;
        itemDrop = null;
        itemName = null;
        material = null;
        nameImage = "";
    }
    public Block init(int id, String name, String nameImage, int type, float st,
                    Item drop){
        this.nameImage = nameImage;
        this.id = id;
        if(!name.equals("")) this.name = name;
        if(!nameImage.equals("")) this.setImage(SM.resize(StaticImage.get(nameImage), SizeTileA, SizeTileA));
        if(type != 0) this.setType(type);
        if(st != 0.0F) this.setStrength(st);
        if(drop != null) this.itemDrop = drop;
        initLast();
        return this;
    }
    public void initLast(){
        if(!BlockSys.getThere(this))
            BlockSys.block.add(this);
    }
    
    public Block setMaterial(Material ma){
        this.material = ma;
        return this;
    }
    
    public Block clontIns(){
        return new Block().init(id, name, nameImage, type, strength, itemDrop).setMaterial(material);
    }
    
    public void active(){
    }

    public int parser(String str){
        return Integer.parseInt(str);
    }
    
    @Override
    public void paint(Graphics2D g, int x, int y) {
        if(image != null) g.drawImage(image, x, y, null);
    }
    
    @Override
    public void update(){
        if(breaking){
            if((timeEndBreaking - timeBeginBreaking) - (Manager.game.player.delayBreaking*2) > strength * Manager.game.player.delayBreaking){
                breaking = false;
            }
        }
        onUpdate();
    }
    
    public void onUpdate(){
    }
    
    public void setType(String str){
        switch(str){
            case "GAS": this.setType(GAS); break;
            case "SOLID": this.setType(SOLID); break;
            case "LIQUID": this.setType(LIQUID); break;
        }
    }
    public void setType(int i){
        this.type = i;
    }
    public void setImage(BufferedImage im){
        this.image = im;
    }
    public void setStrength(float f){
        this.strength = f;
    }
    public int getType(){
        return type;
    }
    public BufferedImage getImage(){
        return image;
    }
    public float getStrength(){
        return strength;
    }
    
    public void breaking(){
        if(!breaking){
            breaking = true;
            timeBeginBreaking = System.currentTimeMillis();
            timeEndBreaking = System.currentTimeMillis();
        }
        
        if(breaking){
            if(timeEndBreaking - timeBeginBreaking > strength * Manager.game.player.delayBreaking){
                ItemObjectMap ob = null;
                Item it = null;
                if(itemDrop != null){
                    ob = new ItemObjectMap(itemDrop);
                    it = itemDrop;
                    ob.spaw(this);
                    ob.stack.items.add(it);
                    SysObjectMap.add(ob);
                }
                breaking(xId, yId);
                Manager.game.ground.layer.setTile(Block.air, xId, yId);
            }
            timeEndBreaking = System.currentTimeMillis();
        }
    }
    
    public void breaking(int xI, int yI){
    }
}
