package app.game;

import GL.system.Display;
import GL.system.SM;
import GL.system.screen.Screen;
import app.Main;
import static app.Manager.game;
import app.MusicManager;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

/**
 * @author Death
 */
public class GameLoadScreen extends Screen{

    int i;
    BufferedImage image;
    
    public GameLoadScreen(){
        super();
        i = 0;
        image = SM.imgFile("./res/logo.png");
    }

    @Override
    public void paintGUI(Graphics2D g){
        Font f = g.getFont();
        g.setFont(new Font("calibri", 0, 35));
        g.setColor(new Color(0, 0, 0));
        g.fillRect(0, 0, Main.display.getWidth(), Main.display.getHeight());
        g.setColor(new Color(255, 0, 0));
        String str = "Генерация мира...";
        g.drawString(str, Main.display.getWidth() / 2 - SM.getWidthStr(g, str) / 2, Main.display.getHeight() / 2);
        g.setFont(f);
        g.drawImage(image, Display.getWidth() / 2 - image.getWidth() / 2, 0, null);
    }

    @Override
    public void updateGUI(){
        super.updateGUI(); //To change body of generated methods, choose Tools | Templates.
        if(i > 5)
            init();
        i++;
    }
    
    public void init(){
        MusicManager.stop("menu");
        game = new Game();
        game.setVisible(true);
        game.init();
        Main.display.add(game);
        Main.display.remove(this);
        this.setVisible(false);
    }
    
    
}
