package app.game.info;

import GL.system.screen.Render;
import app.Manager;
import app.mobs.MobRender;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import static ru.wladimir.map.Setting.SizeTileA;

/**
 * @author Death
 */
public class Info extends Render{

    public boolean vis, visKeyInf;
    
    public Info() {
        vis = false;
        visKeyInf = true;
    }

    @Override
    public void paint(Graphics2D g) {
        Font f = g.getFont();
        g.setFont(new Font("calibri", 0, 18));
        if(vis){
            drawInfo(g, String.valueOf("X: " + (Manager.game.player.x / SizeTileA)), 5, 5 + 18 + 18*0);
            drawInfo(g, String.valueOf("Y: " + (Manager.game.player.y / SizeTileA)), 5, 5 + 18 + 18*1);
            drawInfo(g, String.valueOf("ID MAP: " + (Manager.game.ground.ID_MAP)), 5, 5 + 18 + 18*2);
            drawInfo(g, String.valueOf("Mob number: " + (MobRender.mobs.size())), 5, 5 + 18 + 18*3);
        }else{
            if(visKeyInf){
                drawInfo(g, String.valueOf("F1 - Открыть информацию"), 5, 5 + 18 + 18*0);
                drawInfo(g, String.valueOf("F2 - Сохраниться"), 5, 5 + 18 + 18*1);
                drawInfo(g, String.valueOf("F3 - Скрыть информацию о клавишах"), 5, 5 + 18 + 18*2);
                drawInfo(g, String.valueOf("M - Магазин"), 5, 5 + 18 + 18*3);
                drawInfo(g, String.valueOf("ECS - Выход в главное меню"), 5, 5 + 18 + 18*4);
            }else{
                drawInfo(g, String.valueOf("F3 - Открыть информацию о клавишах"), 5, 5 + 18 + 18*0);
            }
        }
        g.setFont(f);
    }
    
    private void drawInfo(Graphics2D g, String str, int x, int y){
        g.setColor(new Color(0, 0, 0));
        g.drawString(str, x+1, y+1);
        g.setColor(new Color(200, 200, 200));
        g.drawString(str, x, y);
    }

    @Override
    public void update() {
        
    }
}
