package app.inventory;

import GL.system.SM;
import app.Setting;
import app.item.Item;
import app.item.ItemsSys;
import app.item.StackItems;
import app.player.Listener;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

/**
 * @author Death
 */
public class Container {

    
    public int
            WIDTH_INV = 0,
            HEIGTH_INV = 0;
    
    public int
            POLE_ITEM = (int)(20 * Setting.sizeGui),
            POLE_TEXT = (int)(12 * Setting.sizeGui),
            LENGTH_BETWEEN_POLE = (int)(5 * Setting.sizeGui);
    

    public StackItems[][] stack;
    public int x,y;
    public BufferedImage image;
    // есть ли стак?
    public boolean markStack;

    public Container(){
        markStack = false;
        image = null;
        x = 0;
        y = 0;
    }
    public void init(int wInv, int hInv){
        this.WIDTH_INV = wInv;
        this.HEIGTH_INV = hInv;
        stack = new StackItems[WIDTH_INV][HEIGTH_INV];
        for(int i = 0; i < WIDTH_INV; i++){
            for(int j = 0; j  < HEIGTH_INV; j++){
                stack[i][j] = null;
            }
        }
    }
    
    
    public void paint(Graphics2D g){
        drawSlot(g);
    }
    
    private void drawSlot(Graphics2D g){
        g.drawImage(image, x, y, null);
        g.setColor(new Color(0, 0, 0));
        Font f = g.getFont();
        g.setFont(new Font("calibri", 0, 11));
        for(int i = 0; i < WIDTH_INV; i++){
            for(int j = 0; j  < HEIGTH_INV; j++){
                if(stack[i][j] != null){
                    BufferedImage im = ItemsSys.getItemById(stack[i][j].idItems).image;
                    int x1 = x + LENGTH_BETWEEN_POLE + POLE_ITEM/2 - im.getWidth()/2 + i*(POLE_ITEM + LENGTH_BETWEEN_POLE);
                    int y1 = y + LENGTH_BETWEEN_POLE + POLE_ITEM/2 - im.getHeight()/2 + j * (POLE_ITEM + LENGTH_BETWEEN_POLE + POLE_TEXT);
                    g.drawImage(im, x1, y1, null);
                    String str = String.valueOf(stack[i][j].items.size());
                    g.drawString(str, x + LENGTH_BETWEEN_POLE + POLE_ITEM/2 - SM.getWidthStr(g, str) / 2 + i*(POLE_ITEM + LENGTH_BETWEEN_POLE), y + LENGTH_BETWEEN_POLE + POLE_ITEM + POLE_TEXT + j * (POLE_ITEM + LENGTH_BETWEEN_POLE + POLE_TEXT) - 2);
                    takeStackInv(i, j);//выложить из себя
                }
                putStackInv(i, j);//Положить в инв
            }
        }
        g.setFont(f);
    }
    
    
    
    public void takeStackInv(int i, int j){
        //Взять(выложить) из себя
        if(markStack){
            if(Listener.mouseInv.x > x + LENGTH_BETWEEN_POLE + i*(POLE_ITEM + LENGTH_BETWEEN_POLE)
                    && Listener.mouseInv.y > y + LENGTH_BETWEEN_POLE + j*(POLE_ITEM + LENGTH_BETWEEN_POLE + POLE_TEXT)
                    && Listener.mouseInv.x < x + LENGTH_BETWEEN_POLE + i*(POLE_ITEM + LENGTH_BETWEEN_POLE) + POLE_ITEM
                    && Listener.mouseInv.y < y + LENGTH_BETWEEN_POLE + j*(POLE_ITEM + LENGTH_BETWEEN_POLE + POLE_TEXT) + POLE_ITEM)
            {
                if(Listener.clickInvL){
                    StackItems s = stack[i][j];
                    stack[i][j] = Cursor.stack;
                    Cursor.stack = s;
                }
                if(Listener.clickInvR){
                    if(Cursor.stack == null)
                        Cursor.stack = new StackItems(stack[i][j].items.get(0));
                    Cursor.stack.items.add(stack[i][j].items.get(0));
                    stack[i][j].items.remove(0);
                    if(stack[i][j].items.isEmpty()){
                        stack[i][j] = null;
                    }
                }
                markStack = false;
            }
        }
    }
    public void putStackInv(int i, int j){
        //Положить в инв
        if(markStack && Cursor.stack != null){
            if(Listener.mouseInv.x > x + LENGTH_BETWEEN_POLE + i*(POLE_ITEM + LENGTH_BETWEEN_POLE)
                    && Listener.mouseInv.y > y + LENGTH_BETWEEN_POLE + j*(POLE_ITEM + LENGTH_BETWEEN_POLE + POLE_TEXT)
                    && Listener.mouseInv.x < x + LENGTH_BETWEEN_POLE + i*(POLE_ITEM + LENGTH_BETWEEN_POLE) + POLE_ITEM
                    && Listener.mouseInv.y < y + LENGTH_BETWEEN_POLE + j*(POLE_ITEM + LENGTH_BETWEEN_POLE + POLE_TEXT) + POLE_ITEM)
            {
                if(Listener.clickInvL){
                    if(Cursor.stack != null && stack[i][j] != null){
                        stack[i][j].addStack(Cursor.stack);
                        if(Cursor.stack.items.isEmpty())
                            Cursor.stack = null;
                    }else{
                        StackItems s = stack[i][j];
                        stack[i][j] = Cursor.stack;
                        Cursor.stack = s;
                    }
                }
                if(Listener.clickInvR){
                    if(stack[i][j] == null)
                        stack[i][j] = new StackItems(Cursor.stack.items.get(0));
                    stack[i][j].items.add(Cursor.stack.items.get(0));
                    Cursor.stack.items.remove(0);
                    if(Cursor.stack.items.isEmpty()){
                        Cursor.stack = null;
                    }
                }
                markStack = false;
            }
        }
    }
    public boolean addItem(Item it){
        for(int i = 0; i < WIDTH_INV; i++){
            for(int j = 0; j < HEIGTH_INV; j++){
                if(stack[i][j] == null){
                    stack[i][j] = new StackItems(it);
                    stack[i][j].add(it);
                    return true;
                }
                if(stack[i][j].add(it) == 1){return true;}
            }
        }
        return false;
    }
    
}
