package app.inventory;

import GL.system.Display;
import GL.system.SM;
import app.Manager;
import app.Setting;
import app.item.Item;
import app.item.ItemsSys;
import app.player.Player;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;

/**
 * @author Death
 */
public class InventoryBar extends Container{

    
    public int position;
    public boolean visibleFlagPosition;
    long timeDelayIncreasePosition;

    public InventoryBar(){
        super();
    }
    
    public void init(){
        image = SM.imgFile("./res/ui/inventoryBar.png");
        this.image = SM.resize(image, (int)(image.getWidth() * Setting.sizeGui), (int)(image.getHeight() * Setting.sizeGui));
        x = Display.getWidth() / 2 - image.getWidth()/2;
        y = Display.getHeight() - image.getHeight() - 10;
        position = 0;
        visibleFlagPosition = true;
        super.init(9, 1);
    }
    
    @Override
    public void paint(Graphics2D g){
        super.paint(g);
        if(visibleFlagPosition){
            g.setStroke(new BasicStroke(2));
            g.setColor(new Color(0, 0, 255));
            g.drawRect(x - 2 + LENGTH_BETWEEN_POLE + (position * (POLE_ITEM + LENGTH_BETWEEN_POLE)), y - 2 + LENGTH_BETWEEN_POLE, POLE_ITEM + 3, POLE_ITEM + POLE_TEXT + 4);
            g.setStroke(new BasicStroke(1));
        }
    }
    
    
    public void increasePositon(int n){
        if(System.currentTimeMillis() - timeDelayIncreasePosition > 70){
            timeDelayIncreasePosition = System.currentTimeMillis();
            if(position + n >= 0 && position + n < WIDTH_INV)
                position += n;
        }
    }
    public void pickUp(int num, int stackRoom){
        //Забрать
        for(int i = 0; i < num; i++){
            stack[stackRoom][0].items.remove(0);
            if(stack[stackRoom][0].items.isEmpty()){
                stack[stackRoom][0] = null;
            }
        }
    }
    public Item give(int stackRoom){
        if(stack[stackRoom][0] != null)
            return ItemsSys.getItemByName(stack[stackRoom][0].name);
        return null;
    }
    
    
    public void invScreenInit(){
        visibleFlagPosition = false;
        Player p = Manager.game.player;
        x = p.inventory.x + p.inventory.image.getWidth()/2 - image.getWidth()/2;
        y = p.inventory.y + p.inventory.image.getHeight()+ 5;
    }
    public void gameScreenInit(){
        visibleFlagPosition = true;
        x = Display.getWidth() / 2 - image.getWidth()/2;
        y = Display.getHeight() - image.getHeight() - 10;
    }
}
