package app.item;

import GL.system.SM;
import app.Setting;
import java.awt.image.BufferedImage;

/**
 * @author Death
 */
public class Item {
    
    public static final int
                PICK = 1,
                AXE = 2,
                SHOVEL = 3;
    
    public static final Item soil = (new Item()).init(1, "Земля", "soil", 15);
    public static final Item dirst = (new Item()).init(2, "Грязь", "dirst", 20);
    public static final Item tree = (new Item()).init(3, "Дерево", "tree", 10);
    public static final Item board = (new Item()).init(4, "Доска", "board", 35);
    public static final Item stone = (new Item()).init(5, "Камень", "stone", 10);
    public static final Item cobblestone = (new Item()).init(6, "Булыжник", "cobblestone", 13);
    
    public static final Item stick = (new Item()).init(7, "Палка", "stick", 50);
    
    public static final Item woodenPick = (new Item()).init(8, "Деревянная кирка", "woodenPick", 2).setType(PICK);
    public static final Item foliage = (new Item()).init(9, "Листва", "foliage", 50);
    public static final Item grass = (new Item()).init(10, "Трава", "grass", 25);
    
    public static Item getCop(Item m){
        Item i = new Item();
        i.init(m.id, m.name, m.nameImage, m.stackMax);
        return i;
    }
    
    public final int SIZE_ITEM =(int)(12 * Setting.sizeGui);
    public int id;
    public int stackMax;
    public BufferedImage image;
    public String name;
    public int type;
    public String nameImage;
    Object[] recipeObject;
    
    public Item init(int id, String name, String nameImage, int maxItemStack){
        this.id = id;
        this.name = name;
        this.image = SM.resize(StaticImage.get(nameImage), SIZE_ITEM, SIZE_ITEM);
        this.nameImage = nameImage;
        this.stackMax = maxItemStack;
        type = 0;
        initLast();
        return this;
    }
    
    public Item setType(int i){
        this.type = i;
        return this;
    }
    
    private int parser(String str){
        return Integer.parseInt(str);
    }
    
    public void initLast(){
        if(ItemsSys.getItemById(this.id) == null){
            ItemsSys.items.add(this);
        }
    }
}
