package app.item;

import GL.system.SM;
import app.Manager;
import app.block.Block;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import ru.wladimir.map.Layer;
import ru.wladimir.map.Setting;
import ru.wladimir.map.Sprite;

/**
 * @author Death
 */
public class ItemObjectMap extends Sprite{

    public StackItems stack;
    long timeDelay;
    long timeDelayStacking;
    boolean flagStacking;
    int dx, dy;
    
    public ItemObjectMap(Item i) {
        super();
        stack = new StackItems(i);
        timeDelayStacking = 0;
        flagStacking = true;
        BufferedImage im = ItemsSys.getItemById(stack.idItems).image;
        dx = SM.rnd(0, Setting.SizeTileA - im.getWidth());
        dy = SM.rnd(0, Setting.SizeTileA - im.getHeight());
    }
    
    @Override
    public void paint(Graphics2D g) {
        BufferedImage im = ItemsSys.getItemById(stack.idItems).image;
        g.drawImage(im, getXScreen() + Setting.SizeTileA / 2 - im.getWidth() / 2 + dx, getYScreen() + Setting.SizeTileA / 2 - im.getHeight() / 2 + dy, null);
        g.drawString(String.valueOf(stack.items.size()), x, y);
    }
    @Override
    public void update() {
        physics();
        stacking();
    }
    
    
    
    public void spaw(Block block){
        this.x = block.xId * Setting.SizeTileA;
        this.y = block.yId * Setting.SizeTileA;
    }
    public void physics(){
        if(System.currentTimeMillis() - timeDelay > 1000/50){
            timeDelay = System.currentTimeMillis();
            if(!isSolid(0, 1)){
                move(0, 3);
            }
        }
    }
    public boolean isSolid(int dx, int dy){
        Layer l = Manager.game.ground.layer;
        Block b = null;
        if(x + dx >= 0 && y + dy >= 0 && x + dx < l.w * Setting.SizeTileA && y + dy < l.h * Setting.SizeTileA) b = (Block) l.getTile((int)getXId() + dx, (int)getYId() + dy);
        if(b != null && b.getType() == Block.SOLID){
            return true;
        }
        return false;
    }
    public void stacking(){
        if(!flagStacking)
            return;
        if(System.currentTimeMillis() - timeDelayStacking > 300){
            timeDelayStacking = System.currentTimeMillis();
            
            for(int i = 0; i < SysObjectMap.itemsOb.size(); i++){
                if(SysObjectMap.itemsOb.get(i) != this 
                   && SysObjectMap.itemsOb.get(i).stack.idItems == this.stack.idItems 
                   && SysObjectMap.itemsOb.get(i).getYId() == this.getYId()
                   && SysObjectMap.itemsOb.get(i).getXId() == this.getXId()){
                    boolean flagS = true;
                    for(int j = 0; j < stack.items.size(); j++){
                        if(SysObjectMap.itemsOb.get(i).stack.sizeMax > SysObjectMap.itemsOb.get(i).stack.items.size()){
                            SysObjectMap.itemsOb.get(i).stack.add(this.stack.items.get(j));
                            this.stack.remove(this.stack.items.get(j));
                            if(this.stack.items.isEmpty()){
                                SysObjectMap.remove(this);
                            }
                        }else{
//                            System.out.println(stack.items.size());
                            flagStacking = false;
                            flagS = false;
                            break;
                        }
                    }
                    if(flagS){
                        SysObjectMap.itemsOb.remove(this);
                    }
                }
            }
        }
    }
}
