package app.menu;

import GL.system.Display;
import GL.system.SM;
import GL.system.screen.Screen;
import app.Manager;
import app.MusicManager;
import app.dialog.startGame.DialogStartGame;
import app.file.FileGame;
import app.ui.List;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

/**
 * @author Death
 */
public class Menu extends Screen{

    public List listMenu;
    BufferedImage image;
    public app.game.background.Background background;
    
    public Menu() {
        super();
        image = SM.imgFile("./res/logo.png");
        
        MusicManager.play("menu");
        
        listMenu = new List();
        
        listMenu.setLocation(5, 5);
        listMenu.font = new Font("calibri", 0, 25);
        listMenu.colorText = new Color(60, 60, 60, 230);
        listMenu.colorCursor = new Color(60, 60, 60);
        
        listMenu.add("Новая игра");
        listMenu.add("Загрузить");
        listMenu.add("Автор");
        listMenu.add("Выход");
        listMenu.click = new List.IClick() {
            @Override
            public void click(int i) {
                switch(i){
                    case 0: new DialogStartGame(); break;
                    case 1: Manager.appGame(); FileGame.load(); break;
                    case 2: Manager.appAuthor(); break;
                    case 3: System.exit(0); break;
                }
            }
        };
        
        background = new app.game.background.Background();
        
        this.addRender(background);
        this.addGUI(listMenu);
    }

    @Override
    public void paintGUI(Graphics2D g){
        super.paintGUI(g);
        g.drawImage(image, 0, Display.getHeight() - image.getHeight(), null);
    }
    
    
}
