package app.player;

import app.Main;
import app.Manager;
import app.game.Game;
import app.block.Block;
import app.block.BlockSys;
import app.mobs.MobRender;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import ru.wladimir.map.ObjectMap;
import static ru.wladimir.map.Setting.SizeTileA;

/**
 * @author Death
 */
public class Cursor extends ObjectMap{

    public boolean clickL, clickR;
    Block block;
    
    public Cursor(){
        super();
    }
    
    public void init(){
        block = (Block) Manager.game.ground.layer.getTile(0, 0);
        clickL = false;
        clickR = false;
        Main.display.add(Listener.mouseGame);
        xId = (-Manager.game.map.x + Listener.mouseGame.x) / SizeTileA;
        yId = (-Manager.game.map.y + Listener.mouseGame.y) / SizeTileA;
    }

    @Override
    public void paint(Graphics2D g, int x, int y) {
        if(Manager.game.player.holdoutBlock(this)){
            g.setColor(new Color(140, 20, 200, 80));
            g.fillRoundRect(x, y, SizeTileA, SizeTileA, 6, 6);
            g.setColor(new Color(140, 20, 200, 250));
            g.setStroke(new BasicStroke(3));
            g.drawRoundRect(x, y, SizeTileA, SizeTileA, 6, 6);
            g.setStroke(new BasicStroke(1));
        }
    }
    @Override
    public void update() {
        if(clickR){
            MobRender.act(this);
            if(Manager.game.player.holdoutBlock(this)){
                if(     Manager.game.ground.layer.getTile((int)xId, (int)yId).id == Block.air.id ||
                        ((Block)Manager.game.ground.layer.getTile((int)xId, (int)yId)).type == Block.LIQUID){
                    putBlock();
                }else{
                    ((Block)Manager.game.ground.layer.getTile((int)xId, (int)yId)).active();
                }
            }
        }
        if(clickL){
            MobRender.ataka();
            if(Manager.game.player.holdoutBlock(this)){
                if(Manager.game.ground.layer.getTile((int)xId, (int)yId).id != Block.air.id){
                    if(block != null){
                        if(block.xId == ((Block) Manager.game.ground.layer.getTile((int)xId, (int)yId)).xId
                                && block.yId == ((Block) Manager.game.ground.layer.getTile((int)xId, (int)yId)).yId){
                            block.breaking();
                        }else{
                            block = (Block) Manager.game.ground.layer.getTile((int)xId, (int)yId);
                        }
                    }
                }
            }
        }
        xId = (-Manager.game.map.x + Listener.mouseGame.x) / SizeTileA;
        yId = (-Manager.game.map.y + Listener.mouseGame.y) / SizeTileA;
        if(xId < 0)
            xId = 0;
        if(yId < 0)
            yId = 0;
        if(xId >= Manager.game.ground.layer.w)
            xId = Manager.game.ground.layer.w-1;
        if(yId >= Manager.game.ground.layer.h)
            yId = Manager.game.ground.layer.h-1;
    }
    
    public void putBlock(){
        Game g = Manager.game;
        if(g.player.inventoryBar.give(g.player.inventoryBar.position) != null){
            Block b = BlockSys.getNewBlock(g.player.inventoryBar.give(g.player.inventoryBar.position).name);
            g.ground.layer.setTile(b, (int)xId, (int)yId);
            if(g.player.gameMode != Player.CREATIVE){
                g.player.inventoryBar.pickUp(1, g.player.inventoryBar.position);
            }
        }
    }
}
