package app.player;

import GL.system.listener.Key;
import GL.system.listener.Mouse;
import app.Main;
import app.Manager;
import app.file.FileGame;
import app.game.Game;
import app.item.SysObjectMap;
import app.mobs.Mob;
import app.mobs.MobRender;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import ru.wladimir.map.Setting;

/**
 * @author Death
 */
public class Listener {

    public static final Key keyGame = new Key();
    public static final Mouse mouseGame = new Mouse();
    
    public static final Key keyInv = new Key();
    public static final Mouse mouseInv = new Mouse();
    
    public static boolean clickInvL, clickInvR;
    public static long timeDelayUpClick;
    
    public static void init(){
        timeDelayUpClick = System.currentTimeMillis();
        clickInvL = false;
        clickInvR = false;
        Main.display.add(keyGame);
        Main.display.add(mouseGame);
        keyGame.processing = true;
        mouseGame.processing = true;
        keyGame.add(new Key.IPressedKey() {
            @Override
            public void pressed(int keyCode) {
                Game g = Manager.game;
                switch(keyCode){
                    case KeyEvent.VK_W: g.player.wK = true; break;
                    case KeyEvent.VK_S: g.player.sK = true; break;
                    case KeyEvent.VK_A: g.player.aK = true; break;
                    case KeyEvent.VK_D: g.player.dK = true; break;
                    case KeyEvent.VK_F1: Manager.game.info.vis = !Manager.game.info.vis; break;
                    case KeyEvent.VK_F2: FileGame.save(); break;
                    case KeyEvent.VK_F3: Manager.game.info.visKeyInf = !Manager.game.info.visKeyInf; break;
                    case KeyEvent.VK_E: upClickE(true); break;
                    case KeyEvent.VK_O: Setting.SizeTileA ++; break;
                    case KeyEvent.VK_P: Setting.SizeTileA --; break;
                    case KeyEvent.VK_0: System.out.println(SysObjectMap.itemsOb.size()); break;
                    case KeyEvent.VK_ESCAPE: Manager.appMenu(); break;
                    case KeyEvent.VK_F10: MobRender.add(Mob.mob_1.cop()); break;
                }
            }
        });
        keyGame.add(new Key.IReleasedKey() {
            @Override
            public void released(int keyCode) {
                Game g = Manager.game;
                switch(keyCode){
                    case KeyEvent.VK_W: g.player.wK = false; break;
                    case KeyEvent.VK_S: g.player.sK = false; break;
                    case KeyEvent.VK_A: g.player.aK = false; break;
                    case KeyEvent.VK_D: g.player.dK = false; break;
                    case KeyEvent.VK_M: Manager.game.shopScreen.setVis(true); break;
                }
            }
        });
        mouseGame.add(new Mouse.ClickButton() {
            Game game = Manager.game;
            @Override
            public void pressed(int click) {
                if(click == MouseEvent.BUTTON1){
                   game.cursor.clickL = true;
                }
                if(click == MouseEvent.BUTTON3){
                   game.cursor.clickR = true;
                }
            }

            @Override
            public void released(int click) {
                if(click == MouseEvent.BUTTON1){
                   game.cursor.clickL = false;
                }
                if(click == MouseEvent.BUTTON3){
                   game.cursor.clickR = false;
                }
            }
        });
        mouseGame.add(new Mouse.IWheel() {
            @Override
            public void wheel(int i){
                if(i == -1){
                    Manager.game.player.inventoryBar.increasePositon(-1);
                }
                if(i == 1){
                    Manager.game.player.inventoryBar.increasePositon(1);
                }
            }
        });
        
        Main.display.add(mouseInv);
        Main.display.add(keyInv);
        mouseInv.processing = false;
        keyInv.processing = false;
        mouseInv.add(new Mouse.ClickButton() {
            @Override
            public void pressed(int click){
                switch(click){
                    case MouseEvent.BUTTON1:
                        clickMark();
                        clickInvL = true;
                        break;
                    case MouseEvent.BUTTON3:
                        clickMark();
                        clickInvR = true; 
                        break;
                }
            }

            @Override
            public void released(int click){
                switch(click){
                    case MouseEvent.BUTTON1: clickInvL = false; break;
                    case MouseEvent.BUTTON3: clickInvR = false; break;
                }
            }
            
            public void clickMark(){
                Manager.game.player.inventory.markStack = true;
                Manager.game.player.inventoryBar.markStack = true;
            }
        });
        keyInv.add(new Key.IPressedKey() {
            @Override
            public void pressed(int keyCode){
                switch(keyCode){
                    case KeyEvent.VK_E: upClickE(false); break;
                }
            }
        });
    }
    
    public static void upClickE(boolean v){
        if(!(System.currentTimeMillis() - timeDelayUpClick > 100))
            return;
        Manager.game.invScreen.setVisible(v); 
        timeDelayUpClick = System.currentTimeMillis();
        mouseInv.processing = !mouseInv.processing;
        keyInv.processing = !keyInv.processing;
        mouseGame.processing = !mouseGame.processing;
        keyGame.processing = !keyGame.processing;
    }
    
}
