package app.player.body;

import GL.system.SM;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

/**
 * @author Death
 */
public class Animation {

    BufferedImage[] image;
    int maxFrame;
    public int currentFrame;
    long timeDelay;
    public int timeSleep;

    public Animation(BufferedImage im, int w, int h){
        image = SM.getArrayImage(im, w, h);
        maxFrame = image.length;
        currentFrame = 1;
        timeDelay = 0;
        timeSleep = 150;
    }
    
    public void paint(Graphics2D g, int x, int y){
        g.drawImage(image[currentFrame], x, y, null);
//        System.out.println(x + ":" + y);
    }
    
    public void next(){
        if(!(System.currentTimeMillis() - timeDelay > timeSleep))
            return;
        timeDelay = System.currentTimeMillis();
        currentFrame ++;
        if(currentFrame >= maxFrame)
            currentFrame = 1;
    }
    
    public void back(){
        if(!(System.currentTimeMillis() - timeDelay > timeSleep))
            return;
        timeDelay = System.currentTimeMillis();
        currentFrame --;
        if(currentFrame <= 0)
            currentFrame = maxFrame;
    }
    
}
