package app.player.body;

import GL.system.SM;
import app.player.Player;
import java.awt.Graphics2D;
import static ru.wladimir.map.Setting.SizeTileA;

/**
 * @author Death
 */
public class Body {

    public static int W = 20, H = 50;
    
    public static int
            LEFT = 1,
            RIGHT = 2,
            LEFT_GO = 3,
            RIGHT_GO = 4;
    
    public Animation animationLeft = new Animation(SM.imgFile("./res/player/body/Left_Go.png"), W, H);
    public Animation animationRight = new Animation(SM.imgFile("./res/player/body/Right_Go.png"), W, H);
    
    public Player player;
    public Animation animation;
    
    public int direction;
    
    long timeSleedMove;
    
    public Body(Player pla){
        this.player = pla;
        animation = animationLeft;
        timeSleedMove = 0;
    }
    
    public void paint(Graphics2D g){
        animation.paint(g, player.getXScreen(), player.getYScreen());
    }
    
    public void update(){
        if(System.currentTimeMillis() - timeSleedMove > 200){
            timeSleedMove = System.currentTimeMillis();
            animation.currentFrame = 1;
            if(direction == LEFT_GO)
                direction = LEFT;
            if(direction == RIGHT_GO)
                direction = RIGHT;
        }
    }
    
    public void movePlayer(){
        if(player.aK){
            animation = animationLeft;
            direction = LEFT_GO;
        }
        if(player.dK){
            animation = animationRight;
            direction = RIGHT_GO;
        }
        animation.next();
        if(animation.currentFrame == 1)
            animation.currentFrame = 2;
    }
    
    public void setDirection(int di){
        this.direction = di;
    }
    
    
}
