package app.shop;

import GL.system.Display;
import GL.system.SM;
import GL.system.listener.Key;
import GL.system.listener.Mouse;
import app.Main;
import app.Manager;
import app.dialog.shop.DialogShop;
import app.item.Item;
import app.item.ItemsSys;
import app.player.Listener;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.event.KeyEvent;

/**
 * @author Death
 */
public class ShopScreen{

    Key key;
    public boolean vis;
    String str[] = {
        "1. Блок земли(2м)",
        "2. Блок булыжника(6м)",
        "3. Блок доска(5м)",
        "4. Блок дерева(7м)",
        "5. Блок листвы(10м)",
        "6. Блок камня(8м)",
    };
    Panel panel;
    
    DialogShop dialogShop;
    
    public ShopScreen(){
        dialogShop = new DialogShop();
    }
    
    public void init(){
        key = new Key();
        panel = new Panel();
        Main.display.add(key);
        key.add(new Key.IReleasedKey() {
            @Override
            public void released(int keyCode){
                switch(keyCode){
                    case KeyEvent.VK_ESCAPE: setVis(false); break;
                    case KeyEvent.VK_1: dialogShop.visible("Покупка земли", Item.dirst, 2); break;
                    case KeyEvent.VK_2: dialogShop.visible("Покупка булыжник", Item.cobblestone, 6); break;
                    case KeyEvent.VK_3: dialogShop.visible("Покупка доски", Item.board, 5); break;
                    case KeyEvent.VK_4: dialogShop.visible("Покупка дерева", Item.tree, 7); break;
                    case KeyEvent.VK_5: dialogShop.visible("Покупка листвы", Item.foliage, 10); break;
                    case KeyEvent.VK_6: dialogShop.visible("Покупка камня", Item.stone, 8); break;
                }
            }
        });
        panel.init();
        this.setVis(false);
    }
//    
//    public void purchase(Item s, int mon){
//        if(Manager.game.player.money < mon)
//            return;
//        boolean purch = false;
//        if(Manager.game.player.inventoryBar.addItem(s)){
//            purch = true;
//        }else{
//            if(Manager.game.player.inventory.addItem(s)){
//                purch = true;
//            }
//        }
//        if(purch){
//            Manager.game.player.money -= mon;
//        }
//    }

    public void paint(Graphics2D g){
        Manager.game.background.paint(g);
        
        Font f = g.getFont();
        g.setFont(new Font("calibri", 0, 17));
        g.setColor(new Color(10, 10, 10));
        for(int i = 0; i < str.length; i++){
            g.drawString(str[i], 10, 5 + SM.getHeightStr(g, str[i]) + i * (5 + SM.getHeightStr(g, str[i])));
        }
        g.setFont(f);
        paintMoney(g);
        panel.paint(g);
    }
    
    private void paintMoney(Graphics2D g){
        int x1, y1, w1, h1;
        w1 = 150;
        h1 = 25;
        x1 = Display.getWidth() / 2 - w1 / 2;
        y1 = Display.getHeight() - h1 - 5;
        
        g.setColor(new Color(150, 150, 150));
        g.fillRect(x1, y1, w1, h1);
        g.setColor(new Color(70, 70, 70));
        g.setStroke(new BasicStroke(3));
        g.drawRect(x1, y1, w1, h1);
        g.setStroke(new BasicStroke(1));
        Font f = g.getFont();
        g.setFont(new Font("calibri", 0, 17));
        g.setColor(new Color(10, 10, 10));
        String st = String.valueOf(Manager.game.player.money + " монет");
        g.drawString(st, x1 + w1/2 - SM.getWidthStr(g, st)/2, y1 + h1 - (int)(SM.getHeightStr(g, st) * 0.333));
        g.setFont(f);
        
    }

    public void update(){
        Manager.game.background.update();
        panel.update();
    }
    
    public void setVis(boolean f){
        this.vis = f;
        this.key.processing = f;
        panel.mouse.processing = f;
        Listener.keyGame.processing = !f;
        Listener.mouseGame.processing = !f;
        if(f){
            Manager.game.player.inventoryBar.invScreenInit();
            panel.cons();
        }else{
            Manager.game.player.inventoryBar.gameScreenInit();
            panel.dest();
        }
    }
    
    public class Panel{
        int x, y, w, h;
        Mouse mouse;
        long timeDelay;
        String strMenu[] = {
            "Информация:",
            "(Клавиша). Предмет(стоимость)",
            " ",
            "ESCAPE - Закрыть магазин"
        };
        int xW1, yW1, xW2, yW2;
        public Panel(){
        }
        public void init(){
            timeDelay = 0;
            mouse = new Mouse();
            Main.display.add(mouse);
            w = 400;
            h = 200;
            x = Display.getWidth() - 5;
            y = 5 + Manager.game.player.inventory.image.getHeight() + 5 + Manager.game.player.inventoryBar.image.getHeight() + 5;
        }
        public void cons(){
            xW1 = Manager.game.player.inventory.x;
            yW1 = Manager.game.player.inventory.y;
            xW2 = Manager.game.player.inventoryBar.x;
            yW2 = Manager.game.player.inventoryBar.y;
            
            Manager.game.player.inventory.x = Display.getWidth() - Manager.game.player.inventory.image.getWidth() - 5;
            Manager.game.player.inventory.y = 0 + 5;
            Manager.game.player.inventoryBar.x = Display.getWidth() - Manager.game.player.inventoryBar.image.getWidth() - 5;
            Manager.game.player.inventoryBar.y = Manager.game.player.inventory.image.getHeight() + 5 + 5;
        }
        public void dest(){
            Manager.game.player.inventory.x = xW1;
            Manager.game.player.inventory.y = yW1;
            Manager.game.player.inventoryBar.gameScreenInit();
        }
        public void paint(Graphics2D g){
            g.setColor(new Color(200, 200, 200));
            g.fillRect(x, y, w, h);
            g.setColor(new Color(0, 0, 0));
            g.setStroke(new BasicStroke(2));
            g.drawRect(x, y, w, h);
            g.setStroke(new BasicStroke(1));
            Font f = g.getFont();
            g.setFont(new Font("calibri", 0, 17));
            g.setColor(new Color(10, 10, 10));
            for(int i = 0; i < strMenu.length; i++){
                g.drawString(strMenu[i], x + 5, y + 5 + SM.getHeightStr(g, strMenu[i]) + i * (5 + SM.getHeightStr(g, strMenu[i])));
            }
            g.setFont(f);
            Manager.game.player.inventory.paint(g);
            Manager.game.player.inventoryBar.paint(g);
        }
        public void update(){
            if(!(System.currentTimeMillis() - timeDelay > 1000/50))
                return;
            timeDelay = System.currentTimeMillis();
            if(mouse.x > x && mouse.y > y && mouse.x < x + w && mouse.y < y + h){
                x -= 10;
                if(x < Display.getWidth() - 5 - w)
                    x = Display.getWidth() - 5 - w;
            }else{
                x += 13;
                if(x > Display.getWidth() - 5)
                    x = Display.getWidth() - 5;
            }
            
            if(     mouse.x > Manager.game.player.inventory.x && mouse.y > Manager.game.player.inventory.y && 
                    mouse.x < Manager.game.player.inventory.x + Manager.game.player.inventory.image.getWidth() && 
                    mouse.y < Manager.game.player.inventory.y + Manager.game.player.inventory.image.getHeight()){
                Manager.game.player.inventory.x -= 10;
                if(Manager.game.player.inventory.x < Display.getWidth() - 5 - Manager.game.player.inventory.image.getWidth())
                    Manager.game.player.inventory.x = Display.getWidth() - 5 - Manager.game.player.inventory.image.getWidth();
            }else{
                Manager.game.player.inventory.x += 13;
                if(Manager.game.player.inventory.x > Display.getWidth() - 5)
                    Manager.game.player.inventory.x = Display.getWidth() - 5;
            }
            
            if(     mouse.x > Manager.game.player.inventoryBar.x && mouse.y > Manager.game.player.inventoryBar.y && 
                    mouse.x < Manager.game.player.inventoryBar.x + Manager.game.player.inventoryBar.image.getWidth() && 
                    mouse.y < Manager.game.player.inventoryBar.y + Manager.game.player.inventoryBar.image.getHeight()){
                Manager.game.player.inventoryBar.x -= 10;
                if(Manager.game.player.inventoryBar.x < Display.getWidth() - 5 - Manager.game.player.inventoryBar.image.getWidth())
                    Manager.game.player.inventoryBar.x = Display.getWidth() - 5 - Manager.game.player.inventoryBar.image.getWidth();
            }else{
                Manager.game.player.inventoryBar.x += 13;
                if(Manager.game.player.inventoryBar.x > Display.getWidth() - 5)
                    Manager.game.player.inventoryBar.x = Display.getWidth() - 5;
            }
        }
    }
}
