package app.ui;

import GL.system.SM;
import GL.system.listener.Mouse;
import GL.system.screen.Component;
import app.Main;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.util.ArrayList;

/**
 * @author Death
 */
public class List extends Component{

    public static interface IClick{
        public void click(int i);
    }
    
    ArrayList<String> str;
    public IClick click;
    int posMouse;
    public Font font;
    public Color colorText, colorCursor;
    int alfaColorCursor;
    long timeDelay;
    
    public List() {
        super();
        this.setVisible(true);
        str = new ArrayList<>();
        click = null;
        posMouse = 0;
        font = null;
        Main.display.add(mouse);
        alfaColorCursor = 255;
        colorCursor = new Color(255, 0, 0, 255);
        colorText = new Color(0, 0, 0);
        timeDelay = 0;
        mouse.add(new Mouse.ClickButton() {
            @Override
            public void pressed(int cl) {
            }

            @Override
            public void released(int cl) {
                if(mouse.x > x && mouse.y > y &&
                    mouse.x < x + w && mouse.y < y + h){
                    if(click != null){
                        mouse.processing = false;
                        click.click(posMouse);
                    }
                }
            }
        });
    }

    @Override
    public void paint(Graphics2D g){
        Font f = g.getFont();
        if(font != null) g.setFont(font);
        
        y -= 3;
        for(int i = 0; i < str.size(); i++){
            drawString(g, i, 0);
            if(mouse.x > x + g.getFont().getSize() && mouse.y > y + i * g.getFont().getSize() &&
                    mouse.x < x + g.getFont().getSize() + SM.getWidthStr(g, str.get(i)) && mouse.y < y + i * g.getFont().getSize() + SM.getHeightStr(g, str.get(i))){
                posMouse = i;
            }
            if(SM.getWidthStr(g, str.get(i)) + g.getFont().getSize() > w) w = SM.getWidthStr(g, str.get(i)) + g.getFont().getSize() ;
        }
        y += 3;
        
        h = g.getFont().getSize() * str.size();
        g.setColor(colorCursor);
        g.setStroke(new BasicStroke(2));
        g.setColor(colorCursor.darker());
        g.drawLine(x + (g.getFont().getSize() - 3) / 2, y + g.getFont().getSize() / 2 + (posMouse * g.getFont().getSize()) - 4, x + (g.getFont().getSize() - 3), y + g.getFont().getSize() / 2 + (posMouse * g.getFont().getSize()));
        g.setColor(colorCursor);
        g.drawLine(x, y + g.getFont().getSize() / 2 + (posMouse * g.getFont().getSize()), x + g.getFont().getSize() - 3, y + g.getFont().getSize() / 2 + (posMouse * g.getFont().getSize()));
        g.setColor(colorCursor.darker());
        g.drawLine(x + (g.getFont().getSize() - 3) / 2, y + g.getFont().getSize() / 2 + (posMouse * g.getFont().getSize()) + 4, x + (g.getFont().getSize() - 3), y + g.getFont().getSize() / 2 + (posMouse * g.getFont().getSize()));
        g.setStroke(new BasicStroke(1));
        g.setFont(f);
    }
    
    private void drawString(Graphics2D g, int i, int j){
        g.setColor(new Color(colorText.getRed(), colorText.getGreen(), colorText.getBlue(), 100));
        g.drawString(str.get(i), x + g.getFont().getSize() + 2, y + i * g.getFont().getSize() + g.getFont().getSize() + 2);
        g.setColor(new Color(colorText.getRed(), colorText.getGreen(), colorText.getBlue(), colorText.getAlpha()));
        g.drawString(str.get(i), x + g.getFont().getSize(), y + i * g.getFont().getSize() + g.getFont().getSize());
    }
    
    @Override
    public void update() {
        if(!(System.currentTimeMillis() - timeDelay > 1000/ 40)){
            return;
        }
        timeDelay = System.currentTimeMillis();
        if(mouse.x > x && mouse.y > y &&
                mouse.x < x + w && mouse.y < y + h){
            alfaColorCursor += 10;
            if(alfaColorCursor > 255) alfaColorCursor = 255;
        }else{
            alfaColorCursor -= 8;
            if(alfaColorCursor < 100) alfaColorCursor = 100;
        }
        colorCursor = new Color(colorCursor.getRed(), colorCursor.getGreen(), colorCursor.getBlue(), alfaColorCursor);
    }
    
    public void add(String s){
        this.str.add(s);
    }
    
    public void remove(String s){
        this.str.remove(s);
    }


    
}
