package ru.wladimir.map;

import GL.system.Display;
import java.awt.Graphics2D;
import java.util.ArrayList;

/**
 * @author Death
 */
public final class Layer {

    public Tile[][] tileArray;
    public int xId, yId, w, h;
    private int xxx1, yyy1;
    public ArrayList<ObjectMap> objectMapList;
    public Map map;
    
    public Layer(int w, int h){
        this.w = w;
        this.h = h;
        tileArray = new Tile[w][h];
        xId = 0;
        yId = 0;
        objectMapList = new ArrayList<>();
        xxx1 = 0;
        yyy1 = 0;
    }
    
    public void paint(Graphics2D g, int x, int y){
        int x1 = x, y1 = y;
        this.xxx1 = x;
        this.yyy1 = y;
        for(int i = 0; i < w; i++){
            for(int j = 0; j < h; j++){
                if(x1 + Setting.SizeTileA >= 0 && x1 <= Display.getWidth() &&
                        y1 + Setting.SizeTileA >= 0 && y1 <= Display.getHeight())
                    tileArray[i][j].paint(g, x1, y1);
                y1 += Setting.SizeTileA;
            }   
            y1 = y;
            x1 += Setting.SizeTileA;
        }
        for(int i = 0; i < objectMapList.size(); i++){
            x1 = x + objectMapList.get(i).xId * Setting.SizeTileA;
            y1 = y + objectMapList.get(i).yId * Setting.SizeTileA;
            objectMapList.get(i).paint(g, x1, y1);
        }
    }
    
    public void update(){
        int x1 = xxx1, y1 = yyy1;
        for(int i = 0; i < w; i++){
            for(int j = 0; j < h; j++){
                tileArray[i][j].xId = i;
                tileArray[i][j].yId = j;
                if(     x1 + Setting.SizeTileA >= 0 && x1 <= Display.getWidth() &&
                        y1 + Setting.SizeTileA >= 0 && y1 <= Display.getHeight())
                    tileArray[i][j].update();
                y1 += Setting.SizeTileA;
            }
            y1 = yyy1;
            x1 += Setting.SizeTileA;
        }
        for(int i = 0; i < objectMapList.size(); i++){
            objectMapList.get(i).update();
        }
    }
    
    public void setTile(Tile t, int xI, int yI){
        if(xI < 0 || yI <0 || xI > w || yI > h){
//            System.out.println("Error: 1 | xI: " + xI + " | yI: " + yI + " | id:" + t.id);
            return;
        }
        t.xId = xI;
        t.yId = yI;
        if(xI == -1 || yI == -1){
//            System.out.println("Error: 2 | xI: " + xI + " | yI: " + yI + " | id:" + t.id);
        }
        this.tileArray[xI][yI] = t; 
    }
    
    public Tile getTile(int xI, int yI){
        return tileArray[xI][yI];
    }
    
    public void addMap(Map map){
        this.map = map;
        for(int i = 0; i < w; i++){
            for(int j = 0; j < h; j++){
                tileArray[i][j].map = map;
            }
        }
        for(int i = 0; i < objectMapList.size(); i++){
            objectMapList.get(i).map = map;
        }
    }
}
