package ru.wladimir.map;

import GL.system.Display;
import java.awt.Graphics2D;
import java.util.ArrayList;

/**
 * @author Death
 */
public final class Map {

    public int x, y;
    public ArrayList<Layer> layer;
    ArrayList<Sprite> sprite;

    public Map() {
        layer = new ArrayList<>();
        sprite = new ArrayList<>();
        x = 0;
        y = 0;
    }
    
    public void paint(Graphics2D g){
        //Под
        for(int i = 0; i < sprite.size(); i++){
            if(sprite.get(i).location == Sprite.UNTER)
                sprite.get(i).paint(g);
        }
        for(int i = 0; i < layer.size(); i++){
            layer.get(i).paint(g, x, y);
        }
        //Над
        for(int i = 0; i < sprite.size(); i++){
            if(sprite.get(i).location == Sprite.ADOVE)
                sprite.get(i).paint(g);
        }
    }
    
    public void update(){
        goingBeyond();
        for(int i = 0; i < layer.size(); i++){
            layer.get(i).update();
        }
        for(int i = 0; i < sprite.size(); i++){
            sprite.get(i).update();
        }
    }
    
    public void add(Sprite s){
        s.thisAddMap(this);
        this.sprite.add(s);
    }
    public void remove(Sprite s){
        this.sprite.remove(s);
    }
    public void goingBeyond(){
        if(this.x + this.layer.get(this.layer.size() - 1).w * Setting.SizeTileA < Display.getWidth())
            this.x = Display.getWidth() - this.layer.get(this.layer.size() - 1).w * Setting.SizeTileA;
        if(this.y + this.layer.get(this.layer.size() - 1).h * Setting.SizeTileA < Display.getHeight())
            this.y = Display.getHeight()- this.layer.get(this.layer.size() - 1).h * Setting.SizeTileA;
        if(this.x > 0)
            this.x = 0;
        if(this.y > 0)
            this.y = 0;
        
    }
    
    
}
