package ru.wladimir.map;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import static ru.wladimir.map.ObjectMap.FULL;
import static ru.wladimir.map.ObjectMap.NOPE;

/**
 * @author Death
 */
public class Sprite {

    public static int
        UNTER = 1,//Под
        ADOVE = 2;//Над
    
    public int x, y, w,h;
    public BufferedImage image;
    public int location;
    Map map;

    public Sprite(){
        image = null;
        x = 0;
        y = 0;
        w = 0;
        h = 0;
        location = ADOVE;
    }
    
    public void paint(Graphics2D g){
        
    }
    
    public void update(){
        
    }
    
    public final void thisAddMap(Map m){
        this.map = m;
    }
    
    public final int getXScreen(){
        return map.x + this.x;
    }
    
    public final int getYScreen(){
        return map.y + this.y;
    }
    
    public final int getXId(){
        return x / Setting.SizeTileA;
    }
    
    public final int getYId(){
        return y / Setting.SizeTileA;
    }
    
    public final void setXId(int i){
        this.x = Setting.SizeTileA * i;
    }
    
    public final void setYId(int i){
        this.y =Setting.SizeTileA * i;
    }
    
    public final void move(int dx, int dy){
        this.x += dx;
        this.y += dy;
    }
    
    public final int getTouching(Sprite ob){
        if(this.x >= ob.x && this.y >= ob.y
                && this.x + this.w < ob.x + ob.w
                && this.y + this.h < ob.y + ob.h){
            return FULL;
        }
        if(ob.x >= this.x && ob.y >= this.y
                && ob.x + ob.w < this.x + this.h
                && ob.y + ob.h < this.y + this.h){
            return FULL;
        }
        
        return NOPE;
    }
    
    public final int getTouching(ObjectMap ob){
        if(this.x >= ob.xId * Setting.SizeTileA && this.y >= ob.yId * Setting.SizeTileA
                && this.x + this.w <= ob.xId * Setting.SizeTileA + ob.wId * Setting.SizeTileA
                && this.y + this.h <= ob.yId * Setting.SizeTileA + ob.hId * Setting.SizeTileA){
            return FULL;
        }
        if(ob.xId * Setting.SizeTileA >= this.x && ob.yId * Setting.SizeTileA >= this.y
                && ob.xId * Setting.SizeTileA + ob.wId * Setting.SizeTileA <= this.x + this.w
                && ob.yId * Setting.SizeTileA + ob.hId * Setting.SizeTileA <= this.y + this.h){
            return FULL;
        }
        
        return NOPE;
    }
    
}
