package ru.wladimir.sound;

import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiUnavailableException;
import javax.sound.midi.Sequencer;

/**
 * @author Death
 */
public enum Sound {

    FON_MENU("/fonMenu.mp3"),
    FON_GAME("/city.mid");

    Sequencer sequencer;
    public boolean play;
    thread th;
    
    private Sound(String name){
        String file = "./sound" + name;
        File fileMid = new File(file);
        try{
            sequencer = MidiSystem.getSequencer();
        }catch(MidiUnavailableException ex){
            }
        try{
            sequencer.setSequence(MidiSystem.getSequence(fileMid));
        }catch(InvalidMidiDataException | IOException ex){
            }
        try{
            sequencer.open();
        }catch(MidiUnavailableException ex){
            }
        play = false;
        th = new thread();
    }
    
    public void play(boolean pov){
        sequencer.start();
        if(pov){
            play = true;
            th.start();
        }
    }
    
    public void stop(){
        sequencer.stop();
        play = false;
        th.stop();
    }
    
    public class thread extends Thread{

        public thread(){
            super();
        }

        @Override
        public void run(){
            while(true){
                if(sequencer.isRunning()){
                    try{
                        th.sleep(1000);
                    }catch(InterruptedException ex){
                        Logger.getLogger(Sound.class.getName()).log(Level.SEVERE, null, ex);
                    }
                }else{
                    if(play)
                        sequencer.start();
                    else
                        break;
                }
            }
        }
        
        
    }
}
